﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Data;

namespace MultiComboInXamDataGrid
{
    class ComboData
    {
        public ObservableCollection<Person> people { get; set; } = new ObservableCollection<Person>();

        public ComboData() 
        {
            Person person1 = new Person(1, "Peter", 23);
            Person person2 = new Person(2, "Maria", 21);
            Person person3 = new Person(3, "Victor", 22);
            Person person4 = new Person(4, "Gustavo", 26);
            Person person5 = new Person(5, "John", 22);

            people.Add(person1);
            people.Add(person2);
            people.Add(person3);
            people.Add(person4);
            people.Add(person5);
        }

    }

    public class Person : INotifyPropertyChanged
    {
        private int id;
        private string name;
        private int age;

        public Person() { }

        public Person(int Id, string Name, int Age)
        {
            this.id = Id;
            this.name = Name;
            this.age = Age;
        }

        public int Id
        {
            get { return id; }
            set { this.id = value; }
        }


        public string Name
        {
            get { return name; }
            set { this.name = value; }
        }

        public int Age
        {
            get { return age; }
            set { this.age = value; }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        private void onPropertyChanged(object sender, string propertyName)
        {
            if (this.PropertyChanged != null)
            {
                PropertyChanged(sender, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    class Converter1 : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is string && parameter is ComboData)
            {
                ComboData data = parameter as ComboData;

                Int32.TryParse(value.ToString(), out int result);
                Person res = data.people.Where(i => i.Id == result).FirstOrDefault();

                if (res != null)
                {
                    return res;
                }
            }

            return Binding.DoNothing;
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            if (value is Person)
            {
                return (value as Person).Id;
            }
            return Binding.DoNothing;
        }
    }

   

}
